// Autor / Auteur : Zineb KANDOUSSI (https://www.facebook.com/SchoolSurSeineFR/)
// Creation / Création : Le 15/01/2023
// Description : Control Access System using the RFID reader / Système de contrôle d'accès à l'aide du lecteur RFID

#include <Servo.h>
#include <SPI.h>
#include <MFRC522.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

// You can watch this video to get your own RFID tag/card number (UID):
// https://www.youtube.com/watch?v=tQ5MZ7sGGNE 

const byte monUID[4] = {60, 203, 205, 33};
bool valid=true;
#define PIN_LED_ROUGE 7
#define PIN_LED_VERTE 6
#define PIN_SERVO 5
#define PIN_RST 9
#define PIN_SDA 10

LiquidCrystal_I2C lcd(0x27, 16, 2);
Servo myservo;
MFRC522 rfid(PIN_SDA, PIN_RST);

void setup()
{ 
  SPI.begin();
  rfid.PCD_Init();
  myservo.attach(PIN_SERVO);
  myservo.write(0);  
  pinMode(PIN_LED_ROUGE, OUTPUT);
  pinMode(PIN_LED_VERTE, OUTPUT);

  lcd.init();
  lcd.init();
  lcd.backlight();   
  lcd.setCursor(0, 0); // move cursor to   (0, 0)
  lcd.print("School Sur Seine :)"); // print message at (0, 0)
  delay(5000);
  lcd.clear();
}
void loop()
{

if (rfid.PICC_IsNewCardPresent()) // A tag/card is detected : Badge détecté 
{
  if (rfid.PICC_ReadCardSerial()) 
    {
    for (int i = 0; i < rfid.uid.size; i++) 
    {
    if (rfid.uid.uidByte[i] != monUID[i]) 
      {valid=false;}
    else 
      {valid=true;}
    }
    if (valid == 1) 
      {
      digitalWrite(PIN_LED_VERTE, HIGH);
      myservo.write(90);
      lcd.print("Porte ouverte.");
       // lcd.print("Door open");
      delay(4000);
      lcd.clear();
      digitalWrite(PIN_LED_VERTE, LOW);
      myservo.write(0);
      lcd.print("Porte fermee.");
      // lcd.print("Door closed");
      delay(1000);
      lcd.clear();      
      }
    else 
      { 
      digitalWrite(PIN_LED_ROUGE, HIGH);
      lcd.print("Badge non valide.");
      // lcd.print("Invalid tag.");
      delay(1000);
      digitalWrite(PIN_LED_ROUGE, LOW);
      lcd.clear();
      }
    }
}
}
